<?php

define("GS_NL_SEP","'gs'nl'");      // mon sparateur quivalent  nl
define("GS_TAB_SEP","'gs'tab'");    // mon sparateur quivalent  tab
define("ERR_ON_FILE",        1);
define("ERR_ON_HTML_WIN",    2);
define("ERR_BY_MSG",        4);

error_reporting(0);

function htmlize_gs_serial($err) {
// transforme la chane fournie en HTML :
//    remplace GS_NL_SEP par <br> et GS_TAB_SEP par des blancs
//    chappe les caractres qui doivent l'tre
$err =  str_replace(GS_NL_SEP,"<br />",htmlentities($err));
$err = str_replace(GS_TAB_SEP,"&nbsp; &nbsp; &nbsp;",$err);
return AddSlashes($err);
}

function fileize_gs_serial($err) {
// transforme la chane fournie en chane imprimable
//    remplace GS_NL_SEP par \n et GS_TAB_SEP par \t
$err =  str_replace(GS_NL_SEP,"\n",$err);
$err = str_replace(GS_TAB_SEP,"\t",$err);
return $err;
}

function gs_serialize_array($var,$prelig="") {
// gnre une chane indiquant le type, le nom et la valeur des variables du 
// tableau $var
//    effectue des appels rcursifs si des variables sont des arrays ou des objets
//    indente les psentation grce  un prfixe de ligne

if (sizeof($var)==0) return "$prelig<empty>".GS_NL_SEP;
$str = "";
reset($var);
while (list ($key, $val) = each ($var))
{
    $gtype = gettype($val);
    if ($gtype == "array")
    {
        if ($key != "GLOBALS")
        $str .= "$prelig$gtype : $key";
        $str .= GS_NL_SEP.gs_serialize_array($val,$prelig.GS_TAB_SEP);
    }
    else if ($gtype == "object")
    {
        $str .= "$prelig$gtype : $key";
        $str .= GS_NL_SEP.gs_serialize_array(get_object_vars($val),
                                             $prelig.GS_TAB_SEP);
    }
    else if ($gtype =="resource") {
        $str .= "$prelig$gtype : $key => ".get_resource_type($key).GS_NL_SEP;
    }
    else if ($gtype == "string")
    {
        $str .=  "$prelig$gtype : $key => ".AddCSlashes($val,"\0..\31").GS_NL_SEP;
    }
    else
        {$str .=  "$prelig$gtype : $key => $val".GS_NL_SEP; }
    }
return $str;
}

function gs_error_handler($errno, $errstr, $errfile, $errline, $vars) {
// gestionnaire d'erreurs pour toutes les erreurs sauf E_NOTICE
//    gnre une chane contenant date, fichier, ligne et message d'erreur ainsi
//    que la liste des types, noms et valeurs des variables en cours
//    suivant la valeur de ERR_REPORT, sortie dans une fentre de navigateur
//    ou sur le fichier ERR_FILE avec possibilit d'envoi d'un mail au webmaster
//    --> dans la page fournie au surfeur, n'affiche qu'un message d'excuses...
if ($errno == E_NOTICE) return;

$date = date("d/m/Y H:i:s");
$err  = "-----------------------------------------------------".GS_NL_SEP;
$err .= "$date | dans $errfile, ligne : $errline -- err n$errno, $errstr";
$err .= GS_NL_SEP."Variables :".GS_NL_SEP;
if (strpos($errstr,'PEAR : ') === false) { $err .= gs_serialize_array($vars);}
reset($vars);
$glob = sizeof(array_keys($vars,"PHP_SELF"));
if ($glob==0) $err .= GS_NL_SEP."GLOBALS".GS_NL_SEP.gs_serialize_array($GLOBALS);
if (ERR_REPORT & ERR_ON_HTML_WIN) {
    $erra = htmlize_gs_serial($err);
    echo "<SCRIPT type=\"text/javascript\">\n";
    echo "<!--\n";
    echo "    errwin = window.open (\"\",\"ErrWin\",\"toolbar=no,location=no,";
    echo "directories=no,status=no,scrollbars=yes,resizable=yes,copyhistory=no,";
    echo "width=600,height=600\");\n";
    echo "errwin.document.write(\"<html><head>";
    echo "<title>Errs</title></head><body>\");\n";
    echo "errwin.document.write(\"$erra\");\n";
    echo "errwin.document.write(\"</body></html>\");\n";
    echo "//-->\n";
    echo "</SCRIPT>\n";
    }
if (ERR_REPORT & ERR_ON_FILE) {
    $erra = fileize_gs_serial($err);
    error_log($erra, 3, ERR_FILE);
    }
if (ERR_REPORT & ERR_BY_MSG) {
    $erra = fileize_gs_serial($err);
    mail(ERR_MSG_ADDR,ERR_MSG_SUBJ,$erra);
    }

die("<br><br><b>".ERR_SITE_MSG."</b>");
}

set_error_handler('gs_error_handler');

function pear_error_handler($err_obj) {
$error_string =$err_obj->getMessage()."/".$err_obj->getDebugInfo();
trigger_error("PEAR : ".$error_string, E_USER_ERROR);
}

require_once("PEAR.php");
PEAR::setErrorHandling(PEAR_ERROR_CALLBACK,'pear_error_handler');

?>